
#include <windows.h>

void DropError(void)
{
        LPVOID lpMsgBuf;
        DWORD Error = GetLastError();

        FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
        NULL,
        Error,
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
        (LPTSTR) &lpMsgBuf,
        0,
        NULL
        );

        // Display the string.
        //MessageBox( NULL, (LPTSTR)lpMsgBuf, "GetLastError", MB_OK|MB_ICONINFORMATION );

        // Free the buffer.
        LocalFree( lpMsgBuf );
}

int main()
{
  BITMAPINFO BitMapInfo;
  BITMAP	GetBitMap, SetBitMap;
  HWND hWin;
  HDC hWinDC, hDC;
  RECT rWin;
  HBITMAP hBitMap, hGetBitMap, hSetBitMap;
  void *Bits;

  unsigned int tick1 = GetTickCount(), tick2 = GetTickCount();

  hWin = FindWindow(NULL,"Dwarf Fortress");
  if (hWin == NULL) { return 1;}
  hWinDC = GetDC(hWin);
  hDC = CreateCompatibleDC(hWinDC);
  GetClientRect(hWin, &rWin);
  hBitMap = CreateCompatibleBitmap(hDC, rWin.right - rWin.left, rWin.bottom - rWin.top);
  if (hBitMap == NULL){ DropError(); return 1; }
  BitMapInfo.bmiHeader.biSize = sizeof(BitMapInfo.bmiHeader);
  BitMapInfo.bmiHeader.biBitCount = 0;
  int r = GetDIBits(hDC, hBitMap, 0, 1, NULL, &BitMapInfo, DIB_RGB_COLORS);
  if (r == 0){ DropError(); return 2; }
  DeleteObject(hBitMap);
  BitMapInfo.bmiHeader.biCompression = BI_RGB;
  BitMapInfo.bmiHeader.biBitCount = 32;
  hGetBitMap         = CreateDIBSection(hDC,
                  &BitMapInfo,
                  DIB_RGB_COLORS,
                  (void**)&Bits,
                  NULL,
                  NULL);
  if (hGetBitMap == NULL){ DropError(); return 3; }
  BitMapInfo.bmiHeader.biCompression = BI_RGB;
  BitMapInfo.bmiHeader.biBitCount = 32;
  hSetBitMap         = CreateDIBSection(hDC,
                  &BitMapInfo,
                  DIB_RGB_COLORS,
                  (void**)&Bits,
                  NULL,
                  NULL);
  if (hSetBitMap == NULL){ DropError(); return 4; }
  GetObject(hGetBitMap, sizeof(GetBitMap), (void*)&GetBitMap);
  GetObject(hSetBitMap, sizeof(SetBitMap), (void*)&SetBitMap);

  while(1)
  {
    hWinDC = GetDC(hWin);
    SelectObject(hDC, hGetBitMap);
    BitBlt(hDC, 0, 0, GetBitMap.bmWidth, GetBitMap.bmHeight,  hWinDC, 0, 0, SRCCOPY);

    int PixelX = 10;
    int PixelY = 10;
    int t = GetBitMap.bmWidthBytes*PixelY + PixelX*4;

    if (!(  ((unsigned char*)GetBitMap.bmBits)[t] == 255 &&
            ((unsigned char*)GetBitMap.bmBits)[t+1] == 0   &&
            ((unsigned char*)GetBitMap.bmBits)[t+2] == 255))
    {

    //Начало работы над картинкой

    ((unsigned char*)SetBitMap.bmBits)[t] = 255;
    ((unsigned char*)SetBitMap.bmBits)[t+1] = 0;
    ((unsigned char*)SetBitMap.bmBits)[t+2] = 255;

    for (int i = 0; i < GetBitMap.bmWidthBytes * GetBitMap.bmHeight; i++)
    {
      if (i >= t && i <= t + 4)
      {
              continue;
      }
      ((unsigned char*)SetBitMap.bmBits)[i]   = ((unsigned char*)GetBitMap.bmBits)[i];
    }

    //Окончание работы над картинкой

    }
    SelectObject(hDC, hSetBitMap);
    BitBlt(hWinDC, 0, 0, SetBitMap.bmWidth, SetBitMap.bmHeight,
            hDC, 0, 0, SRCCOPY);
    Sleep(1);
  }
  DeleteObject(hGetBitMap);
  DeleteObject(hSetBitMap);
  DeleteDC(hDC);
  ReleaseDC(hWin, hWinDC);
  return 0;
}
